/***************************************************************************
 *   Copyright (C) 2010 by Volker Lanz <vl@fidra.de>                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA            *
 ***************************************************************************/

#if !defined(IMPORTDIALOGTREE__H)

#define IMPORTDIALOGTREE__H

#include "core/activity.h"

#include <QTreeView>

#include <qglobal.h>

class Category;
class Equipment;
class Profile;
class ImportModel;

class ImportDialogTree : public QTreeView
{
	Q_OBJECT

	public:
		ImportDialogTree(QWidget* parent = NULL);

	signals:
		void numSelectedChanged(int, int);

	public:
		void init(Profile& profile, Activities& activities);
		const QSet<const Activity*>& importActivities() const;

	public slots:
		void selectAllImports(bool);
		void unselectAllImports(bool);
		void setAllCategories(Category* c);
		void setAllEquipment(Equipment* e);
		void onActivated(const QModelIndex& idx);
		void onDataChanged(const QModelIndex&, const QModelIndex&);

	protected:
		ImportModel* sourceModel();
		const ImportModel* sourceModel() const;
};

#endif
